"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@babel/types");
const convert_function_type_annotation_1 = require("./convert_function_type_annotation");
function convertObjectTypeCallProperty(callProperty) {
    if (types_1.isFunctionTypeAnnotation(callProperty.value)) {
        const { typeParams, parameters, returnType } = convert_function_type_annotation_1.convertFunctionTypeAnnotation(callProperty.value);
        return types_1.tsCallSignatureDeclaration(typeParams, parameters, returnType);
    }
    else {
        throw new Error('ObjectCallTypeProperty case not implemented');
    }
}
exports.convertObjectTypeCallProperty = convertObjectTypeCallProperty;
//# sourceMappingURL=convert_object_type_call_property.js.map