"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@babel/types");
const util_1 = require("../util");
const convert_flow_type_1 = require("./convert_flow_type");
const baseNodeProps_1 = require("../utils/baseNodeProps");
function convertOpaqueType(node) {
    if (node.supertype) {
        util_1.warnOnlyOnce('Subtyping constraints in opaque type in Flow is ignored in TypeScript');
    }
    const tsNode = types_1.tsTypeAliasDeclaration(node.id, null, Object.assign(Object.assign({}, convert_flow_type_1.convertFlowType(node.impltype)), baseNodeProps_1.baseNodeProps(node.impltype)));
    tsNode.declare = false;
    return tsNode;
}
exports.convertOpaqueType = convertOpaqueType;
//# sourceMappingURL=convert_opaque_type.js.map