"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@babel/types");
const baseNodeProps_1 = require("../utils/baseNodeProps");
function getPropertyKey(property) {
    let key = property.key;
    let isComputed = false;
    if (types_1.isIdentifier(property.key)) {
        if (property.key.name === '@@iterator') {
            isComputed = true;
            key = Object.assign(Object.assign({}, types_1.memberExpression(types_1.identifier('Symbol'), types_1.identifier('iterator'))), baseNodeProps_1.baseNodeProps(property.key));
        }
        if (property.key.name === '@@asyncIterator') {
            isComputed = true;
            key = Object.assign(Object.assign({}, types_1.memberExpression(types_1.identifier('Symbol'), types_1.identifier('asyncIterator'))), baseNodeProps_1.baseNodeProps(property.key));
        }
    }
    return { key, isComputed };
}
exports.getPropertyKey = getPropertyKey;
//# sourceMappingURL=get_property_key.js.map