"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const types_1 = require("@babel/types");
const util_1 = require("../util");
const replaceWith_1 = require("../utils/replaceWith");
function DeclareOpaqueType(path, state) {
    const node = path.node;
    if (node.supertype) {
        util_1.warnOnlyOnce('Subtyping constraints in opaque type in Flow is ignored in TypeScript');
    }
    const replacement = types_1.tsTypeAliasDeclaration(node.id, null, types_1.tsUnknownKeyword());
    replacement.declare = !state.get('isModuleDeclaration');
    replaceWith_1.replaceWith(path, replacement);
}
exports.DeclareOpaqueType = DeclareOpaqueType;
//# sourceMappingURL=declare_opaque_type.js.map